<div class="swag-guided-shopping-appointment-form">
    {% block swag_guided_shopping_presentation_detail_base_basic_general_card %}
        <sw-card
            class="swag-guided-shopping-appointment-detail-base__general"
            position-identifier="swag-guided-shopping-appointment-detail-base__general"
            :title="isModal ? '' : $tc('swag-guided-shopping-appointment.detailBase.cardTitleAppointmentGeneral')"
            :isLoading="isLoading">
            {% block swag_guided_shopping_presentation_detail_base_basic_general_form %}
                <sw-container columns="1fr" gap="0px 30px">
                    <div>
                        <sw-entity-single-select
                            v-if="!isModal"
                            v-model:value="appointment.presentationId"
                            class="swag-guided-shopping-appointment-detail-presentations__presentation-select"
                            validation="required"
                            required
                            entity="guided_shopping_presentation"
                            :criteria="presentationCriteria"
                            :disabled="!acl.can('guided_shopping_appointment.editor') || isModal"
                            :label="$tc('swag-guided-shopping-appointment.base.general.presentationAssignmentLabel')"
                            :placeholder="$tc('swag-guided-shopping-appointment.base.general.presentationAssignmentPlaceholder')"
                            :error="appointmentPresentationIdError"
                        >
                        </sw-entity-single-select>
                    </div>
                </sw-container>

                <sw-container columns="repeat(auto-fit, minmax(150px, 1fr))" gap="0px 30px">
                    <sw-entity-single-select
                        v-model:value="appointment.guideUserId"
                        class="swag-guided-shopping-appointment-detail-presentations__guide-select"
                        validation="required"
                        :required="appointment.mode === 'guided'"
                        labelProperty="username"
                        :labelCallback="getUserName"
                        entity="user"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        :label="$tc('swag-guided-shopping-appointment.base.configuration.guideUserAssignmentLabel')"
                        :placeholder="$tc('swag-guided-shopping-appointment.base.configuration.guideUserAssignmentPlaceholder')"
                        :error="appointmentGuideUserIdError">
                    </sw-entity-single-select>

                    <sw-single-select
                        v-model:value="appointment.mode"
                        class="swag-guided-shopping-appointment-detail-presentations__mode-select"
                        :label="$tc('swag-guided-shopping-appointment.base.configuration.modeLabel')"
                        :helpText="$tc('swag-guided-shopping-appointment.base.configuration.modeHelpText')"
                        :options="modes"
                        @update:value="onChangeMode"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                    >
                        <template
                            #result-label-property="{ item, index, labelProperty, valueProperty, searchTerm, highlightSearchTerm, getKey }"
                        >
                            {{ getKey(item, labelProperty) }}
                        </template>
                    </sw-single-select>
                </sw-container>

                <sw-container columns="1fr" gap="0px 30px">
                    <div>
                        <sw-text-field
                            name="appointmentName"
                            v-model:value="appointment.name"
                            validation="required"
                            :disabled="!acl.can('guided_shopping_appointment.editor')"
                            :label="$tc('swag-guided-shopping-appointment.base.general.appointmentNameLabel')"
                            required
                            :placeholder="placeholder(appointment, 'name')"
                            :error="appointmentNameError"
                        >
                        </sw-text-field>
                    </div>
                </sw-container>

                <sw-container columns="1fr" gap="0px 30px">
                    <div>
                        <sw-select-attendees
                            :label="$tc('swag-guided-shopping-appointment.base.general.participantsReceiversLabel')"
                            :placeholder="$tc('swag-guided-shopping-appointment.base.attendees.attendeeAssignmentPlaceholder')"
                            labelProperty="email"
                            :invited-attendees="appointmentInvitedAttendees"
                            @change="changeValue"
                        />

                        <swag-guided-shopping-appointment-email
                            v-if="!appointment._isNew && appointment.id"
                            :attendees="appointmentInvitedAttendees"
                            :appointmentId="appointment.id"
                            @removeAttendee="removeAttendee"
                        >
                        </swag-guided-shopping-appointment-email>

                        <sw-switch-field
                            name="attendeeRestrictionType"
                            class="swag-guided-shopping-appointment-detail-base__active sw-switch-field-no-spacing"
                            :label="$tc('swag-guided-shopping-appointment.base.configuration.publicSettingLabel')"
                            :value="appointment.attendeeRestrictionType === attendeeRestrictionTypes[1].value"
                            @update:value="onChangeType"
                        >
                        </sw-switch-field>
                    </div>
                </sw-container>

                <sw-container columns="1fr 1fr" gap="0px 30px">
                    <sw-datepicker
                        :config="datepickerConfig"
                        dateType="datetime"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        :label="appointment.mode === 'guided' ? $tc('swag-guided-shopping-appointment.base.configuration.accessibleFromLabel') : $tc('swag-guided-shopping-appointment.base.configuration.accessibleFromForUnguidedLabel')"
                        :required="appointment.mode === 'guided'"
                        validation="required"
                        v-model:value="appointment.accessibleFrom"
                        :error="appointmentAccessibleFromError"
                        :placeholder-text="$tc('swag-guided-shopping-appointment.base.configuration.accessibleFromPlaceholder')"
                        @input="onChangeAccessibleFrom"
                    >
                    </sw-datepicker>
                    <sw-datepicker
                        :config="datepickerConfig"
                        dateType="datetime"
                        :label="appointment.mode === 'guided' ? $tc('swag-guided-shopping-appointment.base.configuration.accessibleToLabel') : $tc('swag-guided-shopping-appointment.base.configuration.accessibleToForUnguidedLabel')"
                        :required="appointment.mode === 'guided'"
                        validation="required"
                        v-model:value="appointment.accessibleTo"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        :error="appointmentAccessibleToError"
                        :placeholder-text="$tc('swag-guided-shopping-appointment.base.configuration.accessibleToPlaceholder')"
                        @input="onChangeAccessibleTo"
                    >
                    </sw-datepicker>
                </sw-container>

                <sw-container columns="1fr" gap="0px 30px">
                    <sw-text-editor
                        v-model:value="appointment.message"
                        :label="$tc('swag-guided-shopping-appointment.base.general.htmlMessageLabel')"
                        :allow-inline-data-mapping="true"
                        sanitize-input>
                    </sw-text-editor>
                    <span class="swag-guided-shopping-appointment-detail__mail-preview-template" v-html="mailPreview"></span>
                </sw-container>
            {% endblock %}
        </sw-card>

        <sw-card
            class="swag-guided-shopping-appointment-detail-base__presentation"
            position-identifier="swag-guided-shopping-appointment-detail-base__presentation"
            :title="$tc('swag-guided-shopping-appointment.detailBase.cardTitleAppointmentInvitation')"
            :isLoading="isLoading">
            {% block swag_guided_shopping_presentation_detail_base_basic_presentation_form %}
                <sw-container columns="1fr 1fr" gap="0px 30px">
                    <sw-entity-single-select
                        v-model:value="appointment.salesChannelDomainId"
                        labelProperty="url"
                        :criteria="domainCriteria"
                        class="swag-guided-shopping-appointment-detail-presentations_domain-select"
                        entity="sales_channel_domain"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        :label="$tc('swag-guided-shopping-appointment.base.general.domainAssignmentLabel')"
                        :placeholder="$tc('swag-guided-shopping-appointment.base.general.domainAssignmentPlaceholder')"
                        validation="required"
                        required
                        :error="appointmentSalesChannelDomainIdError"
                    >
                    </sw-entity-single-select>

                    <sw-text-field
                        name="presentationPath"
                        :value="appointmentPresentationPath"
                        validation="required"
                        class="swag-guided-shopping-appointment-detail-base__path"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        :label="$tc('swag-guided-shopping-appointment.base.general.pathLabel')"
                        :helpText="$tc('swag-guided-shopping-appointment.base.configuration.individualizeHelpText')"
                        @input="presentationPathChanged"
                        :placeholder="appointment.id"
                        :error="appointmentPresentationPathError"
                    >
                    </sw-text-field>

                </sw-container>

                <swag-guided-shopping-appointment-urls
                    :appointment="appointment">
                </swag-guided-shopping-appointment-urls>
            {% endblock %}
        </sw-card>

        <sw-card
            v-if="appointment.mode !== 'self'"
            class="swag-guided-shopping-appointment-detail-base__attendees"
            position-identifier="swag-guided-shopping-appointment-detail-base__attendees"
            :title="$tc('swag-guided-shopping-appointment.detailBase.cardTitleAppointmentAttendees')"
            :isLoading="isLoading">
            <sw-container class="swag-guided-shopping-appointment-detail-base__video-audio-settings_container" columns="1fr" gap="0px">
                {% block swag_guided_shopping_presentation_detail_base_basic_video_and_audio_settings %}
                    <sw-single-select
                        v-model:value="appointment.videoAudioSettings"
                        class="swag-guided-shopping-appointment-detail-base__video-audio-settings"
                        :label="$tc('swag-guided-shopping-appointment.base.configuration.videoAudioSettingsLabel')"
                        :options="videoAudioSettings"
                        @update:value="onChangeVideoAudioSettings"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                    >
                    </sw-single-select>
                {% endblock %}
                {% block swag_guided_shopping_presentation_detail_base_basic_video_form %}
                    <sw-switch-field
                        v-if="appointment.videoAudioSettings !== 'none' && appointment.videoChat"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                        name="appointmentBroadcastEnabled"
                        class="swag-guided-shopping-appointment-detail-base__broadcast-enabled sw-switch-field-no-spacing"
                        :label="$tc('swag-guided-shopping-appointment.base.video.isBroadcastEnabledLabel')"
                        v-model:value="appointment.videoChat.startAsBroadcast"
                    </sw-switch-field>
                {% endblock %}
            </sw-container>
        </sw-card>

        {% block swag_guided_shopping_appointment_custom_fields %}
            <sw-card
                v-show="showCustomFieldsCard"
                class="swag-guided-shopping-appointment__custom-fields"
                position-identifier="swag-guided-shopping-appointment__custom-fields"
                :title="$tc('swag-guided-shopping-appointment.base.cardTitleCustomFields')"
                :is-loading="isLoading"
            >
                {% block swag_guided_shopping_appointment_custom_fields_content %}
                    <sw-custom-field-set-renderer
                        show-custom-field-set-selection
                        :entity="appointment"
                        :sets="customFieldSets"
                        :disabled="!acl.can('guided_shopping_appointment.editor')"
                    ></sw-custom-field-set-renderer>
                {% endblock %}
            </sw-card>
        {% endblock %}
    {% endblock %}
</div>
